﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace NewFriendsCounter
{
    public partial class ResetForm : Form
    {
        private MainForm mainForm;

        public ResetForm(MainForm _mainForm)
        {
            InitializeComponent();
            this.mainForm = _mainForm;           
        }

        private void button1_Click(object sender, EventArgs e)
        {   
            if(String.IsNullOrEmpty(this.textBox_initialCount.Text.Trim()))
            {
                MessageBox.Show("请输入初始好友数！");
                this.textBox_initialCount.Focus();
                return;
            }

            this.mainForm.IsHandled = this.checkBox_isHandled.Checked;
            this.mainForm.TodayFriendsCount = int.Parse(this.textBox_initialCount.Text.Trim());       
            
            FileHelper fileHelper = new FileHelper();
            FileStatus fileStatus = fileHelper.VerifyFileIsOpen("每日新加好友记录.doc");
            if (fileStatus == FileStatus.Opened)
            {
                MessageBox.Show("请先关闭文件！");
                return;
            }

            string resetText = String.Format("{0}   重置好友基数为：{1}\r\n", DateTime.Now.ToShortDateString(), int.Parse(this.textBox_initialCount.Text.Trim()));
            File.AppendAllText("每日新加好友记录.doc", resetText);

            this.DialogResult = System.Windows.Forms.DialogResult.OK;
        }

        private void ResetForm_Shown(object sender, EventArgs e)
        {
            this.textBox_initialCount.Focus();
        }
    }
}
